Option Explicit

Dim objShell, objFSO, baseDir, latestDir, previousDir, latest, previous, objExec
Dim latestFile, previousFile, line, extractedPath, duplicateCount, file
Dim tsLatest, tsPrevious, tsDuplicates, tsFinal
Set objShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")

' Set base directory
baseDir = "D:\DWG"

' Initialize variables
latest = ""
previous = ""

' Get the latest and previous folders
Set objExec = objShell.Exec("cmd.exe /c dir /b /ad /o-d """ & baseDir & """")
Do While Not objExec.StdOut.AtEndOfStream
    file = objExec.StdOut.ReadLine()
    If latest = "" Then
        latest = file
    ElseIf previous = "" Then
        previous = file
        Exit Do
    End If
Loop

' Verify we have the directories
If latest = "" Then
    WScript.Quit
End If

If previous = "" Then
    WScript.Quit
End If

' Full paths to the latest and previous folders
latestDir = baseDir & "\" & latest
previousDir = baseDir & "\" & previous

' Create file lists with full paths, sizes, and creation dates
Set tsLatest = objFSO.CreateTextFile("latest_files.txt", True)
Set tsPrevious = objFSO.CreateTextFile("previous_files.txt", True)

ListFiles latestDir, tsLatest
ListFiles previousDir, tsPrevious

tsLatest.Close
tsPrevious.Close

' Clear duplicates.txt before starting
Set tsDuplicates = objFSO.CreateTextFile("duplicates.txt", True)
tsDuplicates.Close

' Compare files and list duplicates in previous_files.txt
Set tsLatest = objFSO.OpenTextFile("latest_files.txt", 1)
Set tsPrevious = objFSO.OpenTextFile("previous_files.txt", 1)
Set tsDuplicates = objFSO.OpenTextFile("duplicates.txt", 8)

Do While Not tsPrevious.AtEndOfStream
    previousFile = tsPrevious.ReadLine()
    duplicateCount = 0
    
    tsLatest.Close
    Set tsLatest = objFSO.OpenTextFile("latest_files.txt", 1)
    Do While Not tsLatest.AtEndOfStream
        latestFile = tsLatest.ReadLine()
        If Split(previousFile, ",")(0) = Split(latestFile, ",")(0) And _
           Split(previousFile, ",")(1) = Split(latestFile, ",")(1) And _
           Split(previousFile, ",")(2) = Split(latestFile, ",")(2) Then
            duplicateCount = 1
            Exit Do
        End If
    Loop
    If duplicateCount > 0 Then
        tsDuplicates.WriteLine Split(previousFile, ",")(3)
    End If
Loop

tsLatest.Close
tsPrevious.Close
tsDuplicates.Close

' Clear final.txt before starting
Set tsFinal = objFSO.CreateTextFile("final.txt", True)
tsFinal.Close

' Extract file paths from duplicates.txt and write to final.txt
If objFSO.FileExists("duplicates.txt") Then
    Set tsDuplicates = objFSO.OpenTextFile("duplicates.txt", 1)
    Set tsFinal = objFSO.OpenTextFile("final.txt", 8)
    Do While Not tsDuplicates.AtEndOfStream
        file = tsDuplicates.ReadLine()
        tsFinal.WriteLine file
    Loop
    tsDuplicates.Close
    tsFinal.Close
End If

' Delete files listed in final.txt
If objFSO.FileExists("final.txt") Then
    Set tsFinal = objFSO.OpenTextFile("final.txt", 1)
    Do While Not tsFinal.AtEndOfStream
        file = tsFinal.ReadLine()
        If objFSO.FileExists(file) Then
            objFSO.DeleteFile file, True ' Force delete without confirmation
        End If
    Loop
    tsFinal.Close
End If

' Delete temporary files
DeleteFileIfExists "duplicates.txt"
DeleteFileIfExists "final.txt"
DeleteFileIfExists "latest_files.txt"
DeleteFileIfExists "previous_files.txt"

' Subroutines and functions
Sub ListFiles(dir, ts)
    Dim folder, file
    For Each folder In objFSO.GetFolder(dir).SubFolders
        ListFiles folder.Path, ts
    Next
    For Each file In objFSO.GetFolder(dir).Files
        ts.WriteLine file.Name & "," & file.Size & "," & file.DateLastModified & "," & file.Path
    Next
End Sub

Sub DeleteFileIfExists(file)
    If objFSO.FileExists(file) Then
        objFSO.DeleteFile file, True ' Force delete without confirmation
    End If
End Sub